/*
 * template-single.c
 * (C)2000 tutimura@nn.iij4u.or.jp
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <limits.h>
#include <math.h>
#include <float.h>
#define NDEBUG   /* ǥХåϥȤˤ */
#include <assert.h>

#include "getopt.c"


#define TRUE            1
#define FALSE           0

#define MAX(a,b)        ( ( (a)>=(b) ) ? (a):(b) )
#define MIN(a,b)        ( ( (a)<=(b) ) ? (a):(b) )
#define ABS(x)          ( ( (x)>=0   ) ? (x):-(x) )
#define SIGN(x)         ( ((x)<0) ? -1 : ((x)>0) )
#define SQR(x)          ( (x)*(x) )
#define SWAP(a,b,tmp)   ( (tmp)=(a), (a)=(b), (b)=(tmp) )
#define NUM(a)          ( sizeof(a)/sizeof(*(a)) )
#define XOR(a,b)        ( !(a) ^ !(b) )
#define EQUAL3(a,b,c)   ( (a)==(b) && (a)==(c) )

#ifndef PI
#define PI              (3.14159265358979323846264)
#endif
#define EXP             (2.71828182845904509)
#define RAD(deg)        ( (deg)*PI/180 )
#define DEG(rad)        ( (rad)/PI*180 )
#define DST(x,y)        sqrt( (x)*(x) + (y)*(y) )
#define DST2(x,y)       ( (x)*(x) + (y)*(y) )
#define ROUND_OFF(x)    floor( (x) + 0.5 )
#define ROUND_OFF2(x)   ( (x) + 0.5 )   /* only when x>0 */

/* global value */
char *command_name;


void *xmalloc( size_t size ) {
    void *s;

    if ( size == 0 ) size++;
    if ( (s=malloc(size)) == NULL ) {
	fprintf( stderr, "malloc : Not enough memory.\n" );
	exit( EXIT_FAILURE );
    }
    return s;
}


void print_usage( void ) {
    printf( "usage: %s [-a] [-b] [number]\n", command_name );
    printf( "  options\n"
            "  -a : ascii\n"
            "  -b : binary\n"
    );
}


int main( int argc, char *argv[] ) {
    int aflag = 0, bflag = 0;
    char *cvalue = NULL;
    int index;
    int c;

    command_name = argv[0];
    opterr = 0;

    while ( (c=getopt(argc,argv,"abc:")) != EOF ) {
        switch (c) {
        case 'a':
            aflag = 1;
            break;
        case 'b':
            bflag = 1;
            break;
        case 'c':
            cvalue = optarg;
            break;
        case '?':
        default:
            fprintf ( stderr, "Unknown option `-%c'.\n", optopt );
            print_usage();
            return EXIT_FAILURE;
        }
    }
    printf( "    a = %d, b = %d, c = '%s'\n", aflag, bflag, cvalue );
    
    for ( index=optind; index<argc; index++ ) {
        printf( "  Non-option argument %s\n", argv[index] );
    }
    return EXIT_SUCCESS;
}
